-- Broker_AltGuild by yess, yessica@fantasymail.de
local guildname = nil

local ldb = LibStub:GetLibrary("LibDataBroker-1.1",true)
local wholib = LibStub:GetLibrary('LibWho-2.0'):Library()

local QTC = LibStub('LibQTipClick-1.1')

local players, dataobj, tooltip
local update = false
local delay = 65
local counter = 0

local function Debug(...)
	local s = "Broker_AltGuild Debug:"
	for i=1,select("#", ...) do
		local x = select(i, ...)
		s = strjoin(" ",s,tostring(x))
	end
	DEFAULT_CHAT_FRAME:AddMessage(s)
end

local function RGBToHex(r, g, b)
	return ("%02x%02x%02x"):format(r*255, g*255, b*255)	
end

local function UpdateText(event, results, a2)
	dataobj.text = #results
	players = results
end

local function updateList()
	if guildname then
		wholib:Who('g-' .. guildname, {queue = wholib.WHOLIB_QUERY_QUIET, timeout = 0, callback = UpdateText})
	else
		dataobj.text = "no guild set"
	end
end

dataobj = ldb:NewDataObject("Broker_AltGuild", {
	type = "data source",
	icon = "Interface\\AddOns\\Broker_AltGuild\\icon",
	label = "Broker_AltGuild",
	text  = "Updating...",
	OnClick = updateList
})

local function MouseHandler(event, cell, arg, button)
	--Debug("MouseHandler",event, cell, arg, button)
	local name = arg
	if button == "RightButton" then
		InviteUnit(name)
	else
		SetItemRef("player:"..name, "|Hplayer:"..name.."|h["..name.."|h", "LeftButton")
	end
end

local function HideTooltip()
	if MouseIsOver(tooltip) then return end
	tooltip:SetScript("OnLeave", nil)
	tooltip:Hide()
	QTC:Release(tooltip)
	tooltip = nil
end

local function LeaveHandler(event, cell, arg)
        QTC.OnLeave(event, cell, arg)
		HideTooltip()
end

function dataobj:OnEnter()
	-- Acquire a tooltip with 3 columns, respectively aligned to left, center and right
	tooltip = QTC:Acquire("AltGuildTooltip", 3, "LEFT", "CENTER","RIGHT")
	tooltip:Clear()
	self.tooltip = tooltip 
	tooltip:SetCallback("OnMouseDown", MouseHandler)
	tooltip:SetCallback("OnLeave", LeaveHandler)
	--tooltip:SetAutoHideDelay(0.2, self)
	
	tooltip:AddNormalLine(guildname or "type /brokerag <guildname> to set the guild to watch.")
	tooltip:AddNormalLine("")
	tooltip:AddNormalLine("Name", "Level","Zone")
	tooltip:AddSeparator(1,1,1,1,0.5)
	
	if players then
		for k,v in pairs(players) do
			local classcolor = RAID_CLASS_COLORS[v.Class:upper()] or {r=0.77, g=0.12 ,b=0.23 }
			local y, x = tooltip:AddLine()
			y, x = tooltip:SetCell(y, 1, "|cff"..RGBToHex(classcolor.r, classcolor.g, classcolor.b)..v.Name,v.Name)
			y, x = tooltip:SetCell(y, 2, v.Level ,v.Name)
			y, x = tooltip:SetCell(y, 3, v.Zone,v.Name)	
		end
	end
	
	tooltip:SmartAnchorTo(self)
	tooltip:SetScript("OnLeave", HideTooltip)
	tooltip.anchor = self
	tooltip:Show()
end

function dataobj:OnLeave()
	HideTooltip()
end

local function slashHandler(msg)
	if msg == "debug" then
		wholib:SetWhoLibDebug(true)
		DEFAULT_CHAT_FRAME:AddMessage("Broker_AltGuild: Debug enabled.")
	else
		guildname = msg
		AltGuildDB = msg
		updateList()
		DEFAULT_CHAT_FRAME:AddMessage("Broker_AltGuild: Guild set to "..msg)
	end
end

SlashCmdList["Broker_AltGuild"] = slashHandler;
SLASH_Broker_AltGuild1 = "/Broker_AltGuild";
SLASH_Broker_AltGuild2 = "/brokerag";

local function OnUpdate(self, elapsed)
	counter = counter + elapsed
	if counter >= delay then
		if update then
			updateList()
		end
		counter = 0
	end
end

local function OnEvent(self, event, addon)
	if event == "PLAYER_ENTERING_WORLD" then
		guildname = AltGuildDB
		update = true
		updateList()
	else
		update = flase
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_LEAVING_WORLD")

frame:SetScript("OnEvent", OnEvent)
frame:SetScript("OnUpdate", OnUpdate)